Index: trunk/tests/FormValidatorTest.php
===================================================================
--- trunk/tests/FormValidatorTest.php	(revision 15)
+++ trunk/tests/FormValidatorTest.php	(revision 25)
@@ -23,5 +23,5 @@
         require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/FormValidator.inc.php';
-        $this->FormValidator =& new FormValidator(PARAM);
+        $this->FormValidator =& new FormValidator();
     }
 
Index: trunk/tests/_email_test_addresses.txt
===================================================================
--- trunk/tests/_email_test_addresses.txt	(revision 25)
+++ trunk/tests/_email_test_addresses.txt	(revision 25)
@@ -0,0 +1,88 @@
+ asdf@domain.com
+Bob Smith asdf@domain.com
+Bob Smith <asdf@domain.com>
+"Bob Smith" asdf@domain.com
+"Bob Smith"a sldkf &D*&F^*&^# @#*$ @#* asdf@domain.com
+ "white space" <asdf@domain.com> 
+ whitespace@domain.com 
+asdf@domain.com (hello donkey)
+<asdf@domain.com>
+asdf@domain.com
+asdf@domain4.com
+asdf@[011.0.0.100]
+asdf@[1.0.0.0]
+asdf&asdf@domain.com
+Fred\ Bloggs@example.com
+Joe.\\Blow@example.com
+user+mailbox@example.com
+customer/department=shipping@example.com
+$A12345@example.com
+!def!xyz%abc@example.com
+_somename@example.com
+cthornhill_94%1@yahoo.com
+    "bob!#$%&'*+-/=?^_`.{|}~rice@domain.com",
+müllér@domain.com
+sarah.adams.2008@femba.ucla.edu
+dig@whap.heck.suddenly.willy.sam.digity.okay.com.org
+kathryn.p.o\'fee@gsk.com
+stephen.j.o\'quinn@gsk.com
+Wallace.v.cunneen@gsk.com
+myrada.a.carpenter@gsk.com
+caro=los.mccumber@tap.com
+$%^%JidO_kdoe*&&2@lkd.vfg
+asdf@[011.00.100]
+asdf@[011.1234.0.100]
+asdf@[011.0.234.0.100]
+asdf@011.0.0.100]
+asdf@[011.0.0.100
+asdf@011.0.0.100
+asdf@domain4.co-mm
+asdf@4domain.com
+asdf@-domain.com
+asdf@dom_ain.com
+asdf@domain-.com
+asdf@-.com
+asdf@asdf--asdf.com
+asdf@asdfas.asdf--asdf.asdfs.com
+myrada.a.carpenter@g.sk..com
+< asdf@domain.com>
+<asdf@domain.com >
+asdf@domain.com>
+<asdf@domain.com
+asdf@domain.com (hello donkey
+"Abc@def"@example.com
+"Fred Bloggs"@example.com
+Abc\@def@example.com
+myrada.a.carpenter@gsk.museums
+"asdf"@domain.com
+asdf[asdf@asdf.com
+asdf\'"+)*#%@^!asdf@asdf.com
+Barbara.gonzalez@
+bnutt-spectrumsales.net
+catherine.algra.2008.anderson.ucla.edu
+cheryl.a.mcguirk
+david.zipse@cgu,edu
+davidzipse@cgu,edu
+deanna.t.lapierre@@wellsfargo.com
+freda@freda\'s.com
+get1@pge,com
+john.lamb.ngc.com
+jslinger@saturnoftroy
+kellywatts@saturnof
+kent.plummer@Solvay
+lakshmi.thirumalai.2007@anderson.
+nraymon@hoaghospital
+.bob@domain.com
+bobrice..@domain.com
+bob..rice@domain.com
+usernameistoolongusernameistoolongusernameistoolongusernameistoolongusernameis@domain.com
+domainistoolong@domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.domainistoolong.com
+<ken@mail.mpundzu.com>
+<lisah@specialtycare4women.com>
+<jknolle@learningchange.com>
+<cd@monstro.com>
+<spoofing@monstro.com>
+lanebecker@gmail.com
+<fabio@monstro.com>
+neville@dynamiccity.org
+<mtbcsc-spamsubmit@jayallen.org>
Index: trunk/tests/_skel.php
===================================================================
--- trunk/tests/_skel.php	(revision 25)
+++ trunk/tests/_skel.php	(revision 25)
@@ -0,0 +1,59 @@
+#!/usr/local/bin/php
+<?php
+/**
+ * Creates new test case file from specified class file.
+ *
+ * @access  public
+ * @param   Only argument is path to file containing class.
+ * @author  Quinn Comendant <quinn@strangecode.com>
+ * @since   01 Dec 2005 13:56:09
+ */
+require_once 'PHPUnit/Skeleton.php';
+
+$dir = dirname(__FILE__) . '/../lib';
+
+if ($_SERVER['argc'] == 2 && file_exists($dir . '/' . $_SERVER['argv'][1])) {
+    $file = $_SERVER['argv'][1];
+    echo 'Proccessing ' . realpath($dir . '/' . $file) . "\n";
+} else {
+    die('First argument or file not found: ' . $_SERVER['argv'][1] . "\n");
+}
+
+preg_match('/([^\.]+)\..*$/i', $file, $match);
+$classname = $match[1];
+
+$ps = new PHPUnit_Skeleton($classname, '../lib/' . $file);
+
+// Generate the test class.
+// Default settings will not include any parent class methods, but
+// will include private methods.
+$ps->createTestClass();
+
+// Write the new test class to file.
+// By default, code to run the test will be included.
+$ps->writeTestClass();
+
+
+// $dir_handle = opendir($dir);
+// while ($dir_handle && ($file = readdir($dir_handle)) !== false) {
+//     if (!preg_match('/^\./', $file) && is_file($dir . '/' . $file)) {
+//         echo 'Proccessing ' . realpath($dir . '/' . $file) . "\n";
+//         
+//         preg_match('/([^\.]+)\..*$/i', $file, $match);
+//         $classname = $match[1];
+// 
+//         $ps = new PHPUnit_Skeleton($classname, '../lib/' . $file);
+//         
+//         // Generate the test class.
+//         // Default settings will not include any parent class methods, but
+//         // will include private methods.
+//         $ps->createTestClass();
+//         
+//         // Write the new test class to file.
+//         // By default, code to run the test will be included.
+//         $ps->writeTestClass();
+// 
+//     }
+// }
+
+?>
Index: trunk/tests/skel.php
===================================================================
--- trunk/tests/skel.php	(revision 15)
+++ 	(revision )
@@ -1,28 +1,0 @@
-<?php
-require_once 'PHPUnit/Skeleton.php';
-
-$dir = dirname(__FILE__) . '/../lib';
-
-$dir_handle = opendir($dir);
-while ($dir_handle && ($file = readdir($dir_handle)) !== false) {
-    if (!preg_match('/^\./', $file) && is_file($dir . '/' . $file)) {
-        echo 'Proccessing ' . realpath($dir . '/' . $file) . "\n";
-        
-        preg_match('/([^\.]+)\..*$/i', $file, $match);
-        $classname = $match[1];
-
-        $ps = new PHPUnit_Skeleton($classname, '../lib/' . $file);
-        
-        // Generate the test class.
-        // Default settings will not include any parent class methods, but
-        // will include private methods.
-        $ps->createTestClass();
-        
-        // Write the new test class to file.
-        // By default, code to run the test will be included.
-        $ps->writeTestClass();
-
-    }
-}
-
-?>