Index: /trunk/lib/Auth_SQL.inc.php
===================================================================
--- /trunk/lib/Auth_SQL.inc.php	(revision 39)
+++ /trunk/lib/Auth_SQL.inc.php	(revision 40)
@@ -312,5 +312,5 @@
         // Return user data if found.
         if ($user_data = mysql_fetch_assoc($qid)) {
-            App::logMsg(sprintf('Authentication successful for %s %s (%s)', $this->_auth, $user_data['user_id'], $username), LOG_DEBUG, __FILE__, __LINE__);
+            App::logMsg(sprintf('Authentication successful for %s %s (%s)', $this->_auth, $user_data['user_id'], $username), LOG_INFO, __FILE__, __LINE__);
             return $user_data;
         } else {
Index: /trunk/lib/Email.inc.php
===================================================================
--- /trunk/lib/Email.inc.php	(revision 39)
+++ /trunk/lib/Email.inc.php	(revision 40)
@@ -25,5 +25,5 @@
     App::raiseMsg(sprintf(_("A confirmation email has been sent to %s."), $frm['email']), MSG_SUCCESS, __FILE__, __LINE__);
 } else {
-    App::logMsg(sprintf('Error sending confirmation email to address %s', $frm['email']), LOG_DEBUG, __FILE__, __LINE__);
+    App::logMsg(sprintf('Error sending confirmation email to address %s', $frm['email']), LOG_NOTICE, __FILE__, __LINE__);
 }
 -------------------------------------------------------------------------------------
@@ -316,5 +316,5 @@
                 return true;
             } else {
-                App::logMsg(sprintf('Invalid email: %s', $email), LOG_DEBUG, __FILE__, __LINE__);
+                App::logMsg(sprintf('Invalid email: %s', $email), LOG_INFO, __FILE__, __LINE__);
                 return false;
             }
Index: /trunk/lib/FormValidator.inc.php
===================================================================
--- /trunk/lib/FormValidator.inc.php	(revision 39)
+++ /trunk/lib/FormValidator.inc.php	(revision 40)
@@ -419,5 +419,5 @@
         if (ip2long($domain) == '-1' && function_exists('checkdnsrr') && !checkdnsrr($domain . '.', 'MX') && gethostbyname($domain) == $domain) {
             $this->addError($form_name, sprintf(_("<strong>%s</strong> is not a valid email domain name"), oTxt($domain)));
-            App::logMsg(sprintf('The email address %s contains an invalid email domain name (%s).', getFormData($form_name), $domain), LOG_DEBUG, __FILE__, __LINE__);
+            App::logMsg(sprintf('The email address %s contains an invalid email domain name (%s).', getFormData($form_name), $domain), LOG_INFO, __FILE__, __LINE__);
             return false;
         }
Index: /trunk/lib/PageNumbers.inc.php
===================================================================
--- /trunk/lib/PageNumbers.inc.php	(revision 39)
+++ /trunk/lib/PageNumbers.inc.php	(revision 40)
@@ -138,11 +138,11 @@
     {
         if (!$this->set_per_page_initialized) {
-            App::logMsg(sprintf('set_per_page not initialized'), LOG_DEBUG, __FILE__, __LINE__);
+            App::logMsg(sprintf('set_per_page not initialized'), LOG_ERR, __FILE__, __LINE__);
         }
         if (!$this->set_page_number_initialized) {
-            App::logMsg(sprintf('set_page_number not initialized'), LOG_DEBUG, __FILE__, __LINE__);
+            App::logMsg(sprintf('set_page_number not initialized'), LOG_ERR, __FILE__, __LINE__);
         }
         if (!$this->set_total_items_initialized) {
-            App::logMsg(sprintf('set_total_items not initialized'), LOG_DEBUG, __FILE__, __LINE__);
+            App::logMsg(sprintf('set_total_items not initialized'), LOG_ERR, __FILE__, __LINE__);
         }
     
Index: /trunk/lib/SpellCheck.inc.php
===================================================================
--- /trunk/lib/SpellCheck.inc.php	(revision 39)
+++ /trunk/lib/SpellCheck.inc.php	(revision 40)
@@ -189,5 +189,5 @@
 				return true;			
 			} else {
-				App::logMsg(sprintf('Failed adding "%s" to personal wordlist: %s', $word, $this->getParam('personal_wordlist')), LOG_ERR, __FILE__, __LINE__);
+				App::logMsg(sprintf('Failed adding "%s" to personal wordlist: %s', $word, $this->getParam('personal_wordlist')), LOG_WARNING, __FILE__, __LINE__);
 				return false;
 			}
@@ -212,5 +212,5 @@
                 return true;
             } else {
-                App::logMsg(sprintf('Failed saving personal wordlist: %s', $this->getParam('personal_wordlist')), LOG_DEBUG, __FILE__, __LINE__);
+                App::logMsg(sprintf('Failed saving personal wordlist: %s', $this->getParam('personal_wordlist')), LOG_ERR, __FILE__, __LINE__);
                 return false;
             }
Index: /trunk/lib/TemplateGlue.inc.php
===================================================================
--- /trunk/lib/TemplateGlue.inc.php	(revision 39)
+++ /trunk/lib/TemplateGlue.inc.php	(revision 40)
@@ -72,5 +72,5 @@
         return $enum[1];
     } else {
-        App::logMsg(sprintf('No set or enum fields found.', null), LOG_DEBUG, __FILE__, __LINE__);
+        App::logMsg(sprintf('No set or enum fields found.', null), LOG_ERR, __FILE__, __LINE__);
         return false;
     }
Index: /trunk/lib/Upload.inc.php
===================================================================
--- /trunk/lib/Upload.inc.php	(revision 39)
+++ /trunk/lib/Upload.inc.php	(revision 40)
@@ -443,4 +443,5 @@
             if (move_uploaded_file($files['tmp_name'][$i], $file_path_name)) {
                 chmod($file_path_name, $this->getParam('dest_file_perms'));
+                App::logMsg(sprintf('File uploaded: %s', $file_path_name), LOG_INFO, __FILE__, __LINE__);
                 $this->raiseMsg(sprintf(_("The file <strong>%s</strong> uploaded successfully."), $file_name), MSG_SUCCESS, __FILE__, __LINE__);
                 if (!isset($custom_file_name) && $files['name'][$i] != $file_name) {
@@ -487,5 +488,5 @@
             return false;
         } else if (unlink($file_path_name)) {
-            App::logMsg(sprintf('Deleted file: %s', $file_path_name), LOG_DEBUG, __FILE__, __LINE__);
+            App::logMsg(sprintf('Deleted file: %s', $file_path_name), LOG_INFO, __FILE__, __LINE__);
         } else {
             $this->raiseMsg(sprintf(_("The file <strong>%s</strong> could not be deleted."), $file_name), MSG_ERR, __FILE__, __LINE__);